-- Percent for RIFT by Vritra

-- Define
local GOLD = {.9,.75,.6,1}

-- Saved Valiable
Per = {
	tgt_x,
	tgt_y,
	fcs_x,
	fcs_y,
	deci,
	fade,
	fontColor,
	fontSize,
	sign,
	targetFrameVisible,
	focusFrameVisible,
}

local function VarLoadEnd()
	if Per.tgt_x == nil then Per.tgt_x = 0 end
	if Per.tgt_y == nil then Per.tgt_y = 0 end
	if Per.fcs_x == nil then Per.fcs_x = 0 end
	if Per.fcs_y == nil then Per.fcs_y = 0 end
	if Per.deci == nil then Per.deci = 1 end
	if Per.fade == nil then Per.fade = false end
	if Per.fontColor == nil then Per.fontColor = GOLD end
	if Per.fontSize == nil then Per.fontSize = 16 end
	if Per.sign == nil then Per.sign = false end
	if Per.targetFrameVisible == nil then Per.targetFrameVisible = true end
	if Per.focusFrameVisible == nil then Per.focusFrameVisible = true end
end

-- local Valiable
local FrameLock = true
local UIInit = false
local LastTargetID, LastFocusID = "", ""

local function GetDetail(unit, member)
	local d = Inspect.Unit.Detail(unit) or false
	if d then
		for k, v in pairs(d) do
			if k == member then
				return(v)
			end
		end
	end
end

local function Fit()
	PercentTextFrame1:ResizeToText()
	PercentTextFrame2:ResizeToText()
	PercentTextFrame3:ResizeToText()
	PercentTextFrame4:ResizeToText()
	local th = PercentTextFrame1:GetHeight()
	local tw = PercentTextFrame1:GetWidth()
	local fh = PercentTextFrame3:GetHeight()
	local fw = PercentTextFrame3:GetWidth()
	PercentTargetFrame:SetHeight(th)
	PercentTargetFrame:SetWidth(tw)
	PercentFocusFrame:SetHeight(fh)
	PercentFocusFrame:SetWidth(fw)
end

local function TextInit(name, parent, i)
	local h = parent:GetHeight()
	name:SetPoint("TOPLEFT", parent, "TOPLEFT", -i, -i)
	name:SetHeight(h)
	name:SetWidth(h*3)
	if Per.fontSize == nil or Per.fontSize == 0 then
		local s = h * 6 / 10
		name:SetFontSize(s)
		Per.fontSize = s
	else
		if name == PercentTextFrame1 or name == PercentTextFrame2 then
			name:SetFontSize(Per.fontSize)
		else
			local th = UI.Native.PortraitTarget:GetHeight() or 175
			local fh = UI.Native.PortraitFocus:GetHeight() or 100
			name:SetFontSize(fh*(Per.fontSize/th))
		end
	end
	if i == 1 then
		name:SetFontColor(unpack(Per.fontColor or GOLD))
	else
		name:SetFontColor(0,0,0,1)
	end
	name:SetLayer(i+1)
end

local function PosInit()
	local ele = UI.Native.PortraitTarget
	local h = ele:GetHeight()
	if not h then
		PercentTargetFrame:SetAllPoints(ele)
		h = PercentTargetFrame:GetHeight()
	end
	if Per.tgt_x == 0 then
		local x = math.ceil(-h * 0.06)
		local y = math.ceil(h * 0.16)
		PercentTargetFrame:SetPoint("TOPLEFT", ele, "TOPLEFT", x, y)
	else
		PercentTargetFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", Per.tgt_x, Per.tgt_y)
	end
	PercentTargetFrame:SetHeight(math.ceil(h / 6))
	PercentTargetFrame:SetWidth(math.ceil(h / 2))
	local alpha = 1
	if Per.fontColor then
		local a = Per.fontColor[4]
		if a then
			alpha = a
		end
	end
	PercentTargetFrame:SetAlpha(alpha)
	if Per.targetFrameVisible == nil then Per.targetFrameVisible = true end
	PercentTargetFrame:SetVisible(Per.targetFrameVisible)

	ele = UI.Native.PortraitFocus
	h = ele:GetHeight()
	if not h then
		PercentFocusFrame:SetAllPoints(ele)
		h = PercentFocusFrame:GetHeight()
	end
	if Per.fcs_x == 0 then
		local x = math.ceil(-h * 0.06)
		local y = math.ceil(h * 0.16)
		PercentFocusFrame:SetPoint("TOPLEFT", ele, "TOPLEFT", x, y)
	else
		PercentFocusFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", Per.fcs_x, Per.fcs_y)
	end
	PercentFocusFrame:SetHeight(math.ceil(h / 6))
	PercentFocusFrame:SetWidth(math.ceil(h / 2))
	PercentFocusFrame:SetAlpha(alpha)
	if Per.focusFrameVisible == nil then Per.focusFrameVisible = true end
	PercentFocusFrame:SetVisible(Per.focusFrameVisible)

	TextInit(PercentTextFrame1,PercentTargetFrame,1)
	TextInit(PercentTextFrame2,PercentTargetFrame,0)
	TextInit(PercentTextFrame3,PercentFocusFrame,1)
	TextInit(PercentTextFrame4,PercentFocusFrame,0)

	UIInit = true
end

local function CheckUICreate()
	if UIInit == false then
		PosInit()
	end

	if FrameLock == false then
		FrameLock = true
		PercentTargetFrame:SetBackgroundColor(0,0,0,0)
	end
end

local function GetPercentStr(v)
	local num = 0
	if type(v) == "number" then
		num = math.min(math.max(v,0),100)
	elseif type(v) == "string" then
		local hp = GetDetail(v,"health")
		local mx = GetDetail(v,"healthMax")
		if hp == 0 or mx == nil or hp == mx then
			return("")
		end
		num =(hp / mx * 100)
	else
		return("")
	end

	local fmt = "%3s"
	if Per.deci == nil then Per.deci = 1 end
	if Per.deci == 1 then
		fmt = "%.1f"
	elseif Per.deci == 2 then
		fmt = "%.2f"
	elseif Per.deci == 3 then
		fmt = "%.3f"
	else
		num = math.ceil(num)
	end
		
	if Per.sign then
		fmt = fmt.."%%"
	end

	return string.format(fmt, num), num
end

local function OnHealth(arg)
	CheckUICreate()

	if Per.targetFrameVisible == nil then Per.targetFrameVisible = true end
	PercentTargetFrame:SetVisible(Per.targetFrameVisible)
	if Per.targetFrameVisible then
		-- Set Target text
		local targetID = Inspect.Unit.Lookup("player.target")
		local pt, num = GetPercentStr(targetID)
		PercentTextFrame1:SetText(pt)
		PercentTextFrame2:SetText(pt)

		-- fade Target
		if Per.fade and pt ~= "" and num then
			local fade = math.min(((num/100-.5))^2*8,1)
			PercentTargetFrame:SetAlpha(fade)
		end

		LastTargetID = targetID	-- for death check
	end

	if Per.focusFrameVisible == nil then Per.focusFrameVisible = true end
	PercentFocusFrame:SetVisible(Per.focusFrameVisible)
	if Per.focusFrameVisible then
		-- Set Focus text
		local focusID = Inspect.Unit.Lookup("focus")
		pt, num = GetPercentStr(focusID)
		PercentTextFrame3:SetText(pt)
		PercentTextFrame4:SetText(pt)

		-- fade Focus
		if Per.fade and pt ~= "" and num then
			local fade = math.min(((num/100-.5))^2*8,1)
			PercentFocusFrame:SetAlpha(fade)
		end

		LastFocusID = focusID	-- for death check
	end
end

local function TextClose()
	PercentTargetFrame:SetVisible(false)
	PercentFocusFrame:SetVisible(false)
	PercentTextFrame1:SetText("")
	PercentTextFrame2:SetText("")
	PercentTextFrame3:SetText("")
	PercentTextFrame4:SetText("")
end

function OnInit(arg)
	if arg == "Percent" then
		Context = UI.CreateContext("Percent")
		PercentTargetFrame = UI.CreateFrame("Frame", "PerTargetFrame", Context)
		PercentFocusFrame = UI.CreateFrame("Frame", "PercentFocusFrame", Context)
		PercentTextFrame1 = UI.CreateFrame("Text", "PercentText1", PercentTargetFrame)
		PercentTextFrame2 = UI.CreateFrame("Text", "PercentText2", PercentTargetFrame)
		PercentTextFrame3 = UI.CreateFrame("Text", "PercentText3", PercentFocusFrame)
		PercentTextFrame4 = UI.CreateFrame("Text", "PercentText4", PercentFocusFrame)

		-- Set position event
		function PercentTargetFrame.Event:LeftDown()
			if FrameLock == false then
				PercentTargetFrame.mouseDown = true
				local mouse = Inspect.Mouse()
				PercentTargetFrame.startX = PercentTargetFrame:GetLeft()
				PercentTargetFrame.startY = PercentTargetFrame:GetTop()
				PercentTargetFrame.mouseStartX = mouse.x
				PercentTargetFrame.mouseStartY = mouse.y
			end
		end

		function PercentTargetFrame.Event:MouseMove()
			if PercentTargetFrame.mouseDown and FrameLock == false then
				local mouse = Inspect.Mouse()
				Per.tgt_x = mouse.x - PercentTargetFrame.mouseStartX + PercentTargetFrame.startX
				Per.tgt_y = mouse.y - PercentTargetFrame.mouseStartY + PercentTargetFrame.startY
				PercentTargetFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", Per.tgt_x, Per.tgt_y)

				-- Synchronize Focus to Target
				local th = UI.Native.PortraitTarget:GetHeight()
				local tw = UI.Native.PortraitTarget:GetWidth()
				local tt = (UI.Native.PortraitTarget:GetTop()-Per.tgt_y)/th
				local tl = (UI.Native.PortraitTarget:GetLeft()-Per.tgt_x)/tw

				local fh = UI.Native.PortraitFocus:GetHeight()
				local fw = UI.Native.PortraitFocus:GetWidth()
				local ft = UI.Native.PortraitFocus:GetTop()-(fh*tt)
				local fl = UI.Native.PortraitFocus:GetLeft()-(fw*tl)

				PercentFocusFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", fl, ft)
				Per.fcs_x = fl
				Per.fcs_y = ft
			end
		end

		function PercentTargetFrame.Event:LeftUp()
			if PercentTargetFrame.mouseDown then
				PercentTargetFrame.mouseDown = false
			end
		end

		function PercentTargetFrame.Event:RightClick()
			if FrameLock == false then
				FrameLock = true
				PercentTargetFrame:SetBackgroundColor(0,0,0,0)
				TextClose()
			end
		end
	end
end

local function TextDemo(v)
	PercentTargetFrame:SetVisible(Per.targetFrameVisible)
	PercentFocusFrame:SetVisible(Per.focusFrameVisible)
	PercentTargetFrame:SetBackgroundColor(0,0,0,.3)
	FrameLock = false
	
	if type(v) ~= "number" then
		v = 100
	end
	local str = GetPercentStr(v)
	PercentTextFrame1:SetText(str)
	PercentTextFrame2:SetText(str)
	PercentTextFrame3:SetText(str)
	PercentTextFrame4:SetText(str)
	Fit()
end

local function PrintVisible()
	if Per.targetFrameVisible == nil then Per.targetFrameVisible = true end
	if Per.focusFrameVisible == nil then Per.focusFrameVisible = true end
	print("TargetVisible="..tostring(Per.targetFrameVisible)..", FocusVisible="..tostring(Per.focusFrameVisible)..".")
end

local function SetValue()
	OKButton:SetHeight(46)	--for rift addon bug
	OKButton:SetWidth(200)
	if Per.targetFrameVisible == nil then Per.targetFrameVisible = true end
	if Per.focusFrameVisible == nil then Per.focusFrameVisible = true end
	if Per.deci == nil then Per.deci = 1 end
	TargetVisibleCheck:SetChecked(Per.targetFrameVisible)
	FocusVisibleCheck:SetChecked(Per.focusFrameVisible)
	SignCheck:SetChecked(Per.sign)
	FadeCheck:SetChecked(Per.fade)
	DecimalSlider:SetPosition(Per.deci)
	DecimalValue:SetText(tostring(Per.deci))
	FontSlider:SetPosition(Per.fontSize)
	FontValue:SetText(tostring(Per.fontSize))
	local r,g,b,a = unpack(Per.fontColor)
	RedSlider:SetPosition(r*100)
	GreenSlider:SetPosition(g*100)
	BlueSlider:SetPosition(b*100)
	a = math.max(a, 0.1)
	AlphaSlider:SetPosition(a*100)
	RedValue:SetText(tostring(r))
	GreenValue:SetText(tostring(g))
	BlueValue:SetText(tostring(b))
	AlphaValue:SetText(tostring(a))
end

local function CreateColorPickerFrame()
	function SetPercentColor()
		local r = RedSlider:GetPosition()/100
		local g = GreenSlider:GetPosition()/100
		local b = BlueSlider:GetPosition()/100
		local a = AlphaSlider:GetPosition()/100
		PercentTextFrame1:SetFontColor(r,g,b,a)
		PercentTextFrame3:SetFontColor(r,g,b,a)
		PercentTargetFrame:SetAlpha(a)
		PercentFocusFrame:SetAlpha(a)
		RedValue:SetText(tostring(r))
		GreenValue:SetText(tostring(g))
		BlueValue:SetText(tostring(b))
		AlphaValue:SetText(tostring(a))
		return {r,g,b,a}
	end

	_ConfigWindow = UI.CreateFrame("RiftWindow", "Percent", Context)
	_ConfigWindow:SetPoint(0,0, UIParent, 0,0, UIParent:GetWidth()/2-_ConfigWindow:GetWidth()/2, UIParent:GetHeight()/2-_ConfigWindow:GetHeight()/2)
	_ConfigWindow:SetTitle("Percent")

	ConfigWindow = UI.CreateFrame("Frame", "ConfigWindow", _ConfigWindow)
	ConfigWindow:SetPoint(0,0, UIParent, 0,0)
	ConfigWindow:SetAllPoints(_ConfigWindow)

	OKButton = UI.CreateFrame("RiftButton", "OKButton", ConfigWindow)
	OKButton:SetText("OK")
	OKButton:SetPoint("BOTTOMCENTER", ConfigWindow, "BOTTOMCENTER", 0, -30)
	OKButton:SetHeight(46)
	OKButton:SetWidth(200)
	function OKButton.Event:LeftPress()
		Per.fontColor = SetPercentColor()
		_ConfigWindow:SetVisible(false)
		TextClose()
		FrameLock = true
		PercentTargetFrame:SetBackgroundColor(0,0,0,0)
	end
	
	-- Target Visible
	TargetVisibleCheck = UI.CreateFrame("RiftCheckbox", "TargetVisibleCheck", ConfigWindow)
	TargetVisibleCheck:SetPoint("TOPLEFT", ConfigWindow, "TOPLEFT", 60, 100)
	function TargetVisibleCheck.Event:CheckboxChange ()
		Per.targetFrameVisible = TargetVisibleCheck:GetChecked()
		if Per.targetFrameVisible == false then
			Per.focusFrameVisible = true
			FocusVisibleCheck:SetChecked(true)
		end
		TextDemo(100)
	end

	TargetVisibleTitle = UI.CreateFrame("Text", "TargetVisibleTitle", ConfigWindow)
	TargetVisibleTitle:SetPoint("LEFTCENTER", TargetVisibleCheck, "RIGHTCENTER")
	TargetVisibleTitle:SetText("Target Visible")

	-- Focus Visible
	FocusVisibleCheck = UI.CreateFrame("RiftCheckbox", "FocusVisibleCheck", ConfigWindow)
	FocusVisibleCheck:SetPoint("TOPCENTER", TargetVisibleCheck, "BOTTOMCENTER", 0, 10)
	function FocusVisibleCheck.Event:CheckboxChange ()
		Per.focusFrameVisible = FocusVisibleCheck:GetChecked()
		if Per.focusFrameVisible == false then
			Per.targetFrameVisible = true
			TargetVisibleCheck:SetChecked(true)
		end
		TextDemo(100)
	end

	FocusVisibleTitle = UI.CreateFrame("Text", "FocusVisibleTitle", ConfigWindow)
	FocusVisibleTitle:SetPoint("LEFTCENTER", FocusVisibleCheck, "RIGHTCENTER")
	FocusVisibleTitle:SetText("Focus Visible")

	-- with "%"
	SignCheck = UI.CreateFrame("RiftCheckbox", "SignCheck", ConfigWindow)
	SignCheck:SetPoint("TOPCENTER", FocusVisibleCheck, "BOTTOMCENTER", 0, 10)
	function SignCheck.Event:CheckboxChange ()
		Per.sign = SignCheck:GetChecked()
		TextDemo(100)
	end

	SignTitle = UI.CreateFrame("Text", "SignTitle", ConfigWindow)
	SignTitle:SetPoint("LEFTCENTER", SignCheck, "RIGHTCENTER")
	SignTitle:SetText("With \"%\" sign")

	-- Fade
	FadeCheck = UI.CreateFrame("RiftCheckbox", "FadeCheck", ConfigWindow)
	FadeCheck:SetPoint("TOPCENTER", SignCheck, "BOTTOMCENTER", 0, 10)
	function FadeCheck.Event:CheckboxChange ()
		Per.fade = FadeCheck:GetChecked()
	end

	FadeTitle = UI.CreateFrame("Text", "FadeTitle", ConfigWindow)
	FadeTitle:SetPoint("LEFTCENTER", FadeCheck, "RIGHTCENTER")
	FadeTitle:SetText("Fade")

	-- Reset
	ResetButton = UI.CreateFrame("RiftButton", "ResetButton", ConfigWindow)
	ResetButton:SetText("Reset")
	ResetButton:SetPoint("TOPRIGHT", ConfigWindow, "TOPRIGHT", -60, 100)
	function ResetButton.Event:LeftPress()
		--FrameLock = true
		PercentTargetFrame:SetBackgroundColor(0,0,0,0)
		Per.tgt_x = 0
		Per.tgt_y = 0
		Per.fcs_x = 0
		Per.fcs_y = 0
		Per.deci = 0
		Per.fade = false
		Per.fontColor = GOLD
		Per.fontSize = 0
		Per.sign = false
		Per.targetFrameVisible = true
		Per.focusFrameVisible = true
		PosInit()
		SetValue()
	end

	-- Font Size
	FontSlider = UI.CreateFrame("RiftSlider", "FontSlider", ConfigWindow)
	FontSlider:SetPoint("CENTER", ConfigWindow, "CENTER", 0, 10)
	FontSlider:SetRange(5, 100)
	function FontSlider.Event:SliderChange()
		Per.fontSize = FontSlider:GetPosition()
		PercentTextFrame1:SetFontSize(Per.fontSize)
		PercentTextFrame2:SetFontSize(Per.fontSize)
		FontValue:SetText(tostring(Per.fontSize))
		local th = UI.Native.PortraitTarget:GetHeight() or 175
		local fh = UI.Native.PortraitFocus:GetHeight() or 100
		local fs = fh*(Per.fontSize/th)
		PercentTextFrame3:SetFontSize(fs)
		PercentTextFrame4:SetFontSize(fs)
		TextDemo(100)
	end
	local w = FontSlider:GetWidth()

	FontTitle = UI.CreateFrame("Text", "FontTitle", ConfigWindow)
	FontTitle:SetPoint("LEFTTOP", FontSlider, "RIGHTTOP", -40 - w, -6)
	FontTitle:SetText("Size")

	FontValue = UI.CreateFrame("Text", "FontValue", ConfigWindow)
	FontValue:SetPoint("LEFTTOP", FontSlider, "RIGHTTOP", 10, -6)

	-- After the decimal point
	DecimalTitle = UI.CreateFrame("Text", "DecimalTitle", ConfigWindow)
	DecimalTitle:SetPoint("LEFTBOTTOM", FontTitle, "LEFTTOP", 0, -16)
	DecimalTitle:SetText("After the decimal point")

	DecimalSlider = UI.CreateFrame("RiftSlider", "DecimalSlider", ConfigWindow)
	DecimalSlider:SetPoint("RIGHTBOTTOM", FontSlider, "RIGHTTOP", 0, -13)
	DecimalSlider:SetRange(0, 3)
	DecimalSlider:SetWidth(128)
	function DecimalSlider.Event:SliderChange ()
		Per.deci = DecimalSlider:GetPosition()
		DecimalValue:SetText(tostring(Per.deci))
		TextDemo(100)
	end

	DecimalValue = UI.CreateFrame("Text", "DecimalValue", ConfigWindow)
	DecimalValue:SetPoint("LEFTTOP", DecimalSlider, "RIGHTTOP", 10, -6)

	-- Color Title
	ColorTitle = UI.CreateFrame("Text", "ColorTitle", ConfigWindow)
	ColorTitle:SetPoint("TOPCENTER", FontSlider, "BOTTOMCENTER", 0, 10)
	ColorTitle:SetText("Color")

	-- Red
	RedSlider = UI.CreateFrame("RiftSlider", "RedSlider", ConfigWindow)
	RedSlider:SetPoint("TOPCENTER", ColorTitle, "BOTTOMCENTER", 0, 10)
	RedSlider:SetRange(0, 100)
	function RedSlider.Event:SliderChange() SetPercentColor() end

	RedText = UI.CreateFrame("Text", "RedText", ConfigWindow)
	RedText:SetPoint("LEFTTOP", RedSlider, "RIGHTTOP", -40 - w, -6)
	RedText:SetText("Red")

	RedValue = UI.CreateFrame("Text", "RedValue", ConfigWindow)
	RedValue:SetPoint("LEFTTOP", RedSlider, "RIGHTTOP", 10, -6)

	-- Green
	GreenSlider = UI.CreateFrame("RiftSlider", "GreenSlider", ConfigWindow)
	GreenSlider:SetPoint("TOPCENTER", RedSlider, "BOTTOMCENTER", 0, 10)
	GreenSlider:SetRange(0, 100)
	function GreenSlider.Event:SliderChange() SetPercentColor() end

	GreenText = UI.CreateFrame("Text", "GreenText", ConfigWindow)
	GreenText:SetPoint("LEFTTOP", GreenSlider, "RIGHTTOP", -40 - w, -6)
	GreenText:SetText("Green")

	GreenValue = UI.CreateFrame("Text", "GreenValue", ConfigWindow)
	GreenValue:SetPoint("LEFTTOP", GreenSlider, "RIGHTTOP", 10, -6)

	-- Blue
	BlueSlider = UI.CreateFrame("RiftSlider", "BlueSlider", ConfigWindow)
	BlueSlider:SetPoint("TOPCENTER", GreenSlider, "BOTTOMCENTER", 0, 10)
	BlueSlider:SetRange(0, 100)
	function BlueSlider.Event:SliderChange() SetPercentColor() end

	BlueText = UI.CreateFrame("Text", "BlueText", ConfigWindow)
	BlueText:SetPoint("LEFTTOP", BlueSlider, "RIGHTTOP", -40 - w, -6)
	BlueText:SetText("Blue")

	BlueValue = UI.CreateFrame("Text", "BlueValue", ConfigWindow)
	BlueValue:SetPoint("LEFTTOP", BlueSlider, "RIGHTTOP", 10, -6)

	-- Alpha
	AlphaSlider = UI.CreateFrame("RiftSlider", "AlphaSlider", ConfigWindow)
	AlphaSlider:SetPoint("TOPCENTER", BlueSlider, "BOTTOMCENTER", 0, 10)
	AlphaSlider:SetRange(10, 100)
	function AlphaSlider.Event:SliderChange() SetPercentColor() end

	AlphaText = UI.CreateFrame("Text", "AlphaText", ConfigWindow)
	AlphaText:SetPoint("LEFTTOP", AlphaSlider, "RIGHTTOP", -40 - w, -6)
	AlphaText:SetText("Alpha")

	AlphaValue = UI.CreateFrame("Text", "AlphaValue", ConfigWindow)
	AlphaValue:SetPoint("LEFTTOP", AlphaSlider, "RIGHTTOP", 10, -6)

	-- Set position event
	function ConfigWindow.Event:LeftDown()
		ConfigWindow.mouseDown = true
		local mouse = Inspect.Mouse()
		ConfigWindow.startX = _ConfigWindow:GetLeft()
		ConfigWindow.startY = _ConfigWindow:GetTop()
		ConfigWindow.mouseStartX = mouse.x
		ConfigWindow.mouseStartY = mouse.y
	end

	function ConfigWindow.Event:MouseMove()
		if ConfigWindow.mouseDown then
			local mouse = Inspect.Mouse()
			local x = mouse.x - ConfigWindow.mouseStartX + ConfigWindow.startX
			local y = mouse.y - ConfigWindow.mouseStartY + ConfigWindow.startY
			_ConfigWindow:SetPoint(0,0, UIParent, 0,0, x, y)
		end
	end

	function ConfigWindow.Event:LeftUp()
		if ConfigWindow.mouseDown then
			ConfigWindow.mouseDown = false
		end
	end
end

local function SlashHandler(cmd)
	cmd = cmd:lower()
	CheckUICreate()
	if cmd == "set" then
		FrameLock = false
		PercentTargetFrame:SetBackgroundColor(0,0,0,.3)
		TextDemo()
		print("Move: LeftDrag Target percent frame, Set: RightClick")
	elseif cmd == "reset" then
		FrameLock = true
		local h = UI.Native.PortraitTarget:GetHeight()
		PercentTargetFrame:SetBackgroundColor(0,0,0,0)
		Per.tgt_x = math.ceil(-h * 0.06)
		Per.tgt_y = math.ceil(h * 0.16)
		PercentTargetFrame:SetPoint("TOPLEFT", UI.Native.PortraitTarget, "TOPLEFT", Per.tgt_x, Per.tgt_y)

		h = UI.Native.PortraitFocus:GetHeight()
		Per.fcs_x = math.ceil(-h * 0.06)
		Per.fcs_y = math.ceil(h * 0.16)
		PercentFocusFrame:SetPoint("TOPLEFT", UI.Native.PortraitFocus, "TOPLEFT", Per.fcs_x, Per.fcs_y)
	elseif cmd == "fade" then
		if Per.fade then
			Per.fade = false
			PercentTargetFrame:SetAlpha(1)
			PercentFocusFrame:SetAlpha(1)
			print("Fade mode off.")
		else
			Per.fade = true
			print("Fade mode on.")
		end
	elseif cmd == "sign" then
		if Per.sign then
			Per.sign = false
			print("\"%\" sign off.")
		else
			Per.sign = true
			print("\"%\" sign on.")
		end
	elseif tonumber(cmd) then
		Per.fontSize = math.min(math.max(tonumber(cmd), 5), 100)
		PercentTextFrame1:SetFontSize(Per.fontSize)
		PercentTextFrame2:SetFontSize(Per.fontSize)
		PercentTextFrame3:SetFontSize(Per.fontSize)
		PercentTextFrame4:SetFontSize(Per.fontSize)
		TextDemo()
	elseif cmd == "visible" then
		if Per.targetFrameVisible == nil then Per.targetFrameVisible = true end
		if Per.focusFrameVisible == nil then Per.focusFrameVisible = true end
		if Per.targetFrameVisible == true and Per.focusFrameVisible == true then
			Per.focusFrameVisible = false
		elseif Per.targetFrameVisible == true and Per.focusFrameVisible == false then
			Per.targetFrameVisible = false
			Per.focusFrameVisible = true
		else
			Per.targetFrameVisible = true
			Per.focusFrameVisible = true
		end
		PrintVisible()
	elseif cmd == "help" then
		print("/percent set|reset|fade|sign|16|visible")
	else
		if _ConfigWindow == nil then
			CreateColorPickerFrame()
		end
		_ConfigWindow:SetVisible(true)
		SetValue()
		TextDemo(100)
	end
end

table.insert(Event.Combat.Death, {function(val)
	for _, v in pairs(val) do
		if v == LastTargetID then
			PercentTargetFrame:SetVisible(false)
		elseif v == LastFocusID then
			PercentFocusFrame:SetVisible(false)
		end
	end
end, "Percent", "OnDeath"})

table.insert(Event.Unit.Detail.Health, {OnHealth, "Percent", "OnHealth"})
table.insert(Event.Addon.Load.End, {OnInit, "Percent", "Initital Setup"})
table.insert(Command.Slash.Register("Percent"), {SlashHandler, "Percent", "SlashCommand"})
table.insert(Event.Addon.SavedVariables.Load.End, {VarLoadEnd, "Percent", "VarLoadEnd"})
